//
//  AppDelegate.m
//  UI1_UIView
//
//  Created by YIem on 15/12/7.
//  Copyright (c) 2015年 www.yiem.net YIem博客. All rights reserved.
//

#import "AppDelegate.h"

@interface AppDelegate ()

@end

@implementation AppDelegate
- (void)dealloc
{
    [_window release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    
    
    // UI添加代码的地方
    
    // 创建一个UIWindow
    // initWithframe 矩形大小
    // [UIScreen mainScreen].bounds   屏幕大小
    self.window = [[UIWindow alloc]initWithFrame:[UIScreen mainScreen].bounds];
    // 设置颜色
    self.window.backgroundColor = [UIColor redColor];
    // 设置为主视图并且可见
    [self.window makeKeyAndVisible];
    // xcode7.0解决崩溃
    // self.window.rootViewController = [[UIViewController alloc]init];
    // 视图类 UIView(视图类基类BaseClass)
    
#if 0
    // 1.创建对象 设置frame属性
    UIView *oneView = [[UIView alloc] initWithFrame:CGRectMake(0, 20, 100, 100)];
    // 2.使用对象 设置属性(如颜色)
    oneView.backgroundColor = [UIColor whiteColor];
    // 3.将视图(oneView)添加到某处(window)显示
    // oneView     称之为    子视图
    // self.window 称之为    父视图
    [self.window addSubview:oneView];
    // 4.内存管理
    [oneView release];
    // 设置属性
    // frame 属性
    oneView.frame = CGRectMake(100, 100, 100, 100) ;
    // 每一个视图对象都有一个子视图数组和父视图
    // 子视图数组
    // 包含在当前视图上添加的所有子视图对象
    NSLog(@"subView: %@", self.window);
    // 父视图
    NSLog(@"superView: %@", oneView.superclass);
    
    
    
    
    
    
    // 打印屏幕尺寸
    NSLog(@"%@", NSStringFromCGRect(self.window.frame));
    
    /*** UIView重要属性 ***/
    // CGXXXMake()函数 快速创建对类型的结构体
    //***** 1. center 中心点
    // center被修改时视图起始点回发生变化
    oneView.center = CGPointMake(100, 100);
    //***** 2. hidden 隐藏/显示  YES/NO
    oneView.hidden = NO;
    //***** 3. alpha 透明度
    // 1是不透明  0.0~0.9 透明度
    oneView.alpha = 0.5;
    //***** 4.tag 标记值    标记
    // 通过标记间接访问对象视图
    oneView.tag = 1000;
    // 根据标记获取对象
    UIView *tagView = [self.window viewWithTag:1000];
    tagView.backgroundColor = [UIColor lightGrayColor];
    
    // 练习:
    // 1.创建两个视图blueView/redView
    // 2.尝试修改各种UIView属性 查看变化
    // 3.将blueView的父视图由self.window->redView 查看变化
    // 4.修改blueView的属性 查看变化
    UIView *twoView = [[UIView alloc]initWithFrame:CGRectMake(200,200, 100, 100)];
    twoView.backgroundColor = [UIColor whiteColor];
    [self.window addSubview:twoView];
    [twoview release];
//    twoView.center = CGPointMake(300, 200);
//    twoView.hidden = NO;
//    twoView.alpha = 0.5;
//    twoView.tag = 1001;
    UIView *tag1View = [self.window viewWithTag:1001];
    tag1View.backgroundColor = [UIColor lightGrayColor];
    UIView *threeView = [[UIView alloc]initWithFrame:CGRectMake(200, 100, 100, 100)];
    threeView.backgroundColor = [UIColor purpleColor];
    [self.window addSubview:threeView];
    [threeView release];
    
    // 父视图的属性修改 子视图也会跟随变化
    // frame设置的坐标系 参照物为当前的父视图 坐标系原点为父视图的左上角
    
#endif
    // aView
    UIView *aView = [[UIView alloc]initWithFrame:CGRectMake(100, 100, 100, 100)];
    aView.backgroundColor = [UIColor magentaColor];
    [self.window addSubview:aView];
    [aView release];
    // bView
    UIView *bView = [[UIView alloc]initWithFrame:aView.frame];
    bView.backgroundColor = [UIColor yellowColor];
    [self.window addSubview:bView];
    [bView release];
    // 操作层级关系
    // 拿到前面  front
//    [self.window bringSubviewToFront:aView];
    // 放到最后 back
//    [self.window sendSubviewToBack:aView];
    // 移除视图 remove
    [bView removeFromSuperview];
    
    // 定时器 NSTimer
    // 每隔固定时间 让某个对象执行某个方法
    // 参数1: 时间间隔(s)
    // 参数2: 某个对象
    // 参数3: 某个方法
    // 参数4: 是否重复
    
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(repeat) userInfo:nil repeats:YES];
    
    
    
    // 内存管理
    [_window release];
    
    /**
     * 创建UI工程的步骤(Single View)
     * 1.删除ViewControoller.h和.m文件
     * 2.工程文件中 general选项中 删除MainInterface处的Main
     * 3.工程文件中 build settings选项中 ARC->MRC
     * 4.AppDelegate.h中 strong->retain
     * 5.AppDelegate.m中 添加dealloc方法
     * 6.AppDelegate.m中 创建UIWindow
     */
    
    
    return YES;
}
- (void)repeat
{
    NSLog(@"随便");
}


- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
